SystemOrganization addCategory: #BrokenClasses!
SystemOrganization addCategory: #'BrokenClasses-Playground'!
SystemOrganization addCategory: #'BrokenClasses-Biology'!
SystemOrganization addCategory: #'BrokenClasses-PhysicsLibrary'!

Trait named: #FlyingTrait
	uses: {}
	category: 'BrokenClasses-Biology'!

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:01:42.746'!
fly: target
	"Happily flying towards the target"
	self inAir ifFalse: [self liftOff].
	self position: target.
	self inAir ifTrue: [self touchDown].
! !

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:01:55.776'!
liftOff
	"Start flying"
	self inAir: True.! !

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:02:07.994'!
touchDown 
	"Stop flying"
	self inAir: False.! !

ORCmdClassRefactoring subclass: #ORCmdUseMethodsRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:42:12.064'!
currentCompositionString

	^ self currentNode theNonMetaClass traitCompositionString! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:34:31.323'!
filterMethods: methods

	^ methods" select: [:m | m sendsToSuper not]"! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'JS 1/22/2013 13:56:43.649'!
label

	^ 'use foreign methods'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:12:24.447'!
longDescription 

	^ 'Use methods of other classes in this class.'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:32:31.644'!
methodLabelsFor: methods

	^ methods collect: [:m | m sendsToSuper 
		ifTrue: [ m selector asString , ' Warning: sends message to super!!' ] 
		ifFalse: [ m selector asString ]  ]! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:24:20.533'!
methodValuesFor: methods

	^ methods collect: [:m | m selector ]! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:09:11.07'!
promptForeignClass

	^ UIManager default chooseClassOrTrait: 'Choose a class to select methods from'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:33:52.038'!
promptSelectedMethodsFor: aClass
	
	| methods |
	aClass ifNil: [^ #()].
	methods := self filterMethods: aClass methodDict values.
	^ OBMultipleChoiceRequest 
		prompt: 'Choose methods to include' 
		labels: ( self methodLabelsFor: methods ) 
		values: ( self methodValuesFor: methods )! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:51:55.71'!
refactoring
	| foreignClass methods |
	foreignClass := self promptForeignClass.
	methods := self promptSelectedMethodsFor: foreignClass.
	^ UseMethodClassRefactoring 
		model: self model
		class: self currentNode theNonMetaClass
		oldCompositionString: self currentCompositionString
		foreignClass: foreignClass
		selectedMethods: methods! !

Dictionary subclass: #ClassUsersMap
	instanceVariableNames: ''
	classVariableNames: 'ClassUsers'
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:18'!
at: key ifAbsentPut: aBlock 
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ (ClassUsers at: key ifAbsentPut: aBlock)! !

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:12'!
at: key put: aCollection
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ ClassUsers at: key put: aCollection! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
+ aTrait
	"Creates a composition with the receiver and aTrait"
	aTrait traitsDo:[:t| self == t ifTrue:[TraitCompositionException
			signal: 'Trait ' , self asString, ' already in composition']].
	^TraitComposition withAll: {self}, aTrait asTraitComposition! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
- anArrayOfSelectors
	"Creates an exclusion"
	^TraitExclusion
		with: self
		exclusions: anArrayOfSelectors! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:46'!
@ anArrayOfAssociations 
	"Creates an alias"
	^TraitAlias with: self aliases: anArrayOfAssociations! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:30'!
addSelectorSilently: selector withMethod: compiledMethod
	super addSelectorSilently: selector withMethod: compiledMethod.
	self instanceSide noteAddedSelector: selector meta: self isMeta.
	"updateTraits of users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:03'!
addTraitUser: aTrait
	self users: (self users copyWith: aTrait)
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 13:34'!
asTraitComposition
	^TraitComposition with: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:44'!
browserIcon
	"Answer an icon to be show in the browser for the receiving class."

	^ self traitComposition isEmpty ifTrue: [^#blank] ifFalse: [^#announcement]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:31'!
classTrait

	^ ClassTrait for: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:40'!
copyTraitExpression

	^ self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 15:44:35.75'!
installInstVarsReferredIn: methods

	| allInstVars |
	allInstVars := Set new.
	methods valuesDo: [:method | allInstVars addAll: (method referredInstVars) ].
	allInstVars do: [:var | (self instVarNames includes: var) ifFalse: [
			self addInstVarName: var] ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:59:24.488'!
installTraitsFrom: aTraitComposition
	"Install the traits from the given composition. This method implements
	the core composition method - all others are just optimizations for
	particular cases. Consequently, the optimized versions can always fall
	back to this method when things get too hairy."
	| allTraits methods |

	(self traitComposition isEmpty and: [aTraitComposition isEmpty]) ifTrue: [^self].

	"Check for cycles"
	allTraits := aTraitComposition gather: [:t | t allTraits copyWith: t].
	(allTraits includes: self) ifTrue:[^self error: 'Cyclic trait definition detected'].

	self traitComposition: aTraitComposition.
	methods := self assembleTraitMethodsFrom: aTraitComposition.
	self installInstVarsReferredIn: methods.
	self installTraitMethodDict: methods.
	self isMeta ifFalse:[self classSide updateTraitsFrom: aTraitComposition].
	
	"updateTraits of users"
	self users do: [:each | each updateTraits ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:49'!
isTraitTransformation
	"Polymorphic with TraitTransformation"
	^false! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:35:47.178'!
notifyOfRecategorizedSelector: element from: oldCategory to: newCategory
	SystemChangeNotifier uniqueInstance selector: element recategorizedFrom: oldCategory to: newCategory inClass: self.

	"classify:under:from:trait: for all users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:02'!
removeTraitUser: aTrait
	self users: (self users copyWithout: aTrait).
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:30'!
trait
	^self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 17:37:22.471'!
traitsDo: aBlock
	aBlock value: self.! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:21'!
users

	^ ClassUsersMap at: (self name asSymbol) ifAbsentPut: [^ #()]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:36:00.746'!
users: aCollection

	^ ClassUsersMap at: (self name asSymbol) put: aCollection! !

ClassRefactoring subclass: #UseMethodClassRefactoring
	instanceVariableNames: 'oldCompositionString foreignClass selectedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!UseMethodClassRefactoring class methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 15:48:10.932'!
model: aModel class: aClass oldCompositionString: compositionString foreignClass: aForeignClass selectedMethods: anArray

	^ (self
		model: aModel
		className: aClass name)
		oldCompositionString: compositionString;
		foreignClass: aForeignClass;
		selectedMethods: anArray;
		yourself  ! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:07:05.214'!
categoryName

	^ self targetClass category asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:12.098'!
classVariableNames

	^ self targetClass classVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:46:39.884'!
foreignClass
	^foreignClass! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:46:52.037'!
foreignClass: aClass
	foreignClass := aClass! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:26:29.252'!
initialize 

	traitCompositionString := '#()'! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:13:04.986'!
instanceVariableNames

	^ self targetClass instanceVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:58:14.686'!
oldCompositionString
	^oldCompositionString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:58:28.026'!
oldCompositionString: aString
	oldCompositionString := aString.! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:42.389'!
poolDictionaries

	^ self targetClass poolDictionaryNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'preconditions' stamp: 'lmn 1/22/2013 16:07:47.552'!
preconditions
	| class fClass |
	class := self targetClass.
	fClass := self foreignClass.
	^ (RBCondition withBlock: [class notNil and: [class isMeta not]]
		errorString: class name, ' is not a valid composit class') &
		(RBCondition withBlock: [ fClass notNil ] errorString: 'Must select a foreign class.' )! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:26.232'!
redefineClassString

	^ self targetSuperclassName, ' subclass: #', className , ' uses: ', self traitCompositionString , ' instanceVariableNames: ''', self instanceVariableNames ,''' classVariableNames:''',self classVariableNames,''' poolDictionaries:''',self poolDictionaries,''' category: ''',self categoryName,''' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:24:26.792'!
selectedMethods
	^selectedMethods! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:24:12.666'!
selectedMethods: anArray
	selectedMethods := anArray! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:39:06.853'!
targetClass

	^ self model classNamed: className! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:08:21.306'!
targetSuperclassName

	^ self targetClass superclass name asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:47:45.952'!
traitCompositionString
|prefix rejectedMethods rejectString|
	(self oldCompositionString = '{}')
		ifTrue: [ prefix := '']
		ifFalse: [ prefix := self oldCompositionString, ' + '].
	rejectedMethods := self foreignClass methodDict keys reject: [:k | self selectedMethods includes: k].
	(rejectedMethods size > 0)
		ifTrue: [rejectString := '-{', ((rejectedMethods collect: [:m | '#', m asString]) join: '. '),'}']
		ifFalse: [rejectString := ''].
		
	^prefix, (self foreignClass name), rejectString! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:16.831'!
transform

	self model defineClass: self redefineClassString! !

Object subclass: #BaseTrait
	instanceVariableNames: 'baseVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 16:32:03.661'!
fastforward

	super isNil.
	^ self! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 15:05:24.449'!
play

	baseVar := 42.
	^ 2! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:15:30.093'!
rewind

	^ self! !

BaseTrait subclass: #SpecialTrait
	instanceVariableNames: 'specialVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!SpecialTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 14:29:10.864'!
play

	^ super play + 4! !

Object subclass: #Creature
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Creature methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:16:24.897'!
position
	^ position! !

!Creature methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:16:24.925'!
position: anObject
	position := anObject! !

Creature subclass: #Insect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Insect subclass: #Ant
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Ant methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:31:56.41'!
crawl: target
	"Happily crawling towards the target."
	self position: target.! !

Insect subclass: #Fly
	uses: FlyingTrait
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Fly class
	uses: FlyingTrait classTrait
	instanceVariableNames: ''!

!Fly methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:37:47.006'!
inAir
	^ inAir! !

!Fly methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:37:47.035'!
inAir: anObject
	inAir := anObject! !

Creature subclass: #Mammal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Mammal subclass: #Bat
	uses: FlyingTrait
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Bat class
	uses: FlyingTrait classTrait
	instanceVariableNames: ''!

!Bat methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:38:01.702'!
inAir
	^ inAir! !

!Bat methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:38:01.73'!
inAir: anObject
	inAir := anObject! !

Mammal subclass: #Dolphin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Dolphin methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:31:45.692'!
swim: target
	"Happily swimming towards the target."

	self position: target.! !

Object subclass: #MovingObject
	instanceVariableNames: 'position speed acceleration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-PhysicsLibrary'!

MovingObject subclass: #FlyingObject
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-PhysicsLibrary'!

!FlyingObject methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:44:40.174'!
fly: target
	"Fly somewhere"
	self inAir ifFalse: [self liftOff].

	"TODO: Update position, speed and acceleration continuously according to the object's flying properties."
	self position: target.

	self inAir ifTrue: [self touchDown].
! !

!FlyingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:45:14.934'!
inAir
	^ inAir! !

!FlyingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:45:14.963'!
inAir: anObject
	inAir := anObject! !

!FlyingObject methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:45:35.339'!
liftOff
	"Start flying"
	self inAir: True.! !

!FlyingObject methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:45:47.926'!
touchDown 
	"Stop flying"
	self inAir: False.! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:36.167'!
acceleration
	^ acceleration! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:36.195'!
acceleration: anObject
	acceleration := anObject! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:56.486'!
position
	^ position! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:56.515'!
position: anObject
	position := anObject! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:41:18.458'!
speed
	^ speed! !

!MovingObject methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:41:18.488'!
speed: anObject
	speed := anObject! !

Object subclass: #OtherTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!OtherTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:36:01.272'!
drive

	^ self! !

!OtherTrait methodsFor: 'as yet unclassified' stamp: 'JS 1/16/2013 11:50:09.079'!
navigate

	^ self! !

Object subclass: #TraitUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!
